#!/usr/bin/env perl

my $infile = $ARGV[0];
my $numfile = $ARGV[1];
my $reps = $ARGV[2];
#my $thd = $ARGV[3];

# count number of reads and build hashes
open(TMP, "$infile");
$rowcount = $ntot = 0;
while(<TMP>)
	{chomp;
	$rowcount++; if ($rowcount==1) {next;}
	@cols = split("\t", $_);
	$rndh{$cols[1]} = $cols[2];
	for ($a=1; $a<=$cols[2]; $a++)
		{
		$luh{$a+$ntot} = $cols[1];
#		print $a+$ntot, "\t", $cols[1], "\n";
		}
	$ntot+=$cols[2];
	}

# loop through list of sampling levels
print "rep\tgenes\tcov\n";
open(NF, $numfile);
while(<NF>)
	{
	chomp;
	$num = $_;
	if ($num>$ntot) {next;}
	for ($z=1; $z<=$reps; $z++)
		{
		print $num, "\t";
		print $z, "\t";

# generate random numbers to pick rows
		my %pickh; my %siteh;
		for ($a=1; $a<=$num; $a++)
			{
			$randi = int(rand($ntot+1));
			$pickh{$randi} = 1;
			}
# pick rows from hash
		foreach $p (sort(keys(%pickh)))
			{
			$conti = $luh{$p};
			$siteh{$conti}++;	
			}

		@skeys = sort(keys(%siteh));
#		$nsk = 0;
#		foreach $n (@skeys)
#			{
#			if ($siteh{$n}/$num >= $thd) {$nsk++;}
#			}
		$nsk = @skeys;
		print $nsk, "\n";
		}
	}
